using namespace std;

/**************************************************/
class Base_Score {

public:

	bool			use_score;
	bool			use_primary_score;
	bool			use_secondary_score;
	double			current_score;

	int				size;
	float			spacing;
	float			origin[3];
	int				span[3];

	XYZCRD			corners[8];
	int				neighbors[8];
	float			cube_coords[3];
	float			int_coords[3];
	int				nearest_neighbor;
	float			x_min, x_max, y_min, y_max, z_min, z_max;

	/* Generic Function Definitions */
	virtual	bool	compute_score(DOCKMol &) { return true; };
	virtual string	output_score_summary(float) { return ""; };
	float			return_current_score() {return current_score;};

	/* Interpolation fxns */
	void			calc_corner_coords();
	bool			check_box_boundaries(float x, float y, float z);
	void			find_grid_neighbors(float x, float y, float z);
	int				find_grid_index(int x, int y, int z);
	float			interpolate(float *grid);

	float			lowest_neighbor(float *grid);
	float			average_neighbor(float *grid);
	float			median_neighbor(float *grid);
	float			interpolate_trilinear(float *grid);
	float			interpolate_sublinear(float *grid);

};

